Custom Functions

In SpreadJS, you can create your own function and add it to sheet. In addition to all the 500+ built-in functions, the SpreadJS Calculation Engine also allows you to create your own custom functions for specific business use cases. They can be defined and called as you would any of the built-in functions.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

You can create your own function by inheriting the GC.Spread.CalcEngine.Functions.Function, as shown in the following code:

    function FactorialFunction() {
       this.name = 'FACTORIAL';
       this.maxArgs = 1;
       this.minArgs = 1;
    }
    FactorialFunction.prototype = new GC.Spread.CalcEngine.Functions.Function();
    FactorialFunction.prototype.evaluate = function (arg) {
       // your own evaluate content
    }
    var factorial = new FactorialFunction();
    sheet.addCustomFunction(factorial);

The evaluate function can return a GC.Spread.CalcEngine.CalcArray object to represent the custom function returns an array as following code:

    MyCustomFunction.prototype.evaluate = function (context) {
        return new GC.Spread.CalcEngine.CalcArray([[1, 2, 3]]);
    } 

After you have added your own function, if you want to remove it or clear all custom functions, use the removeCustomFunction or clearCustomFunctions method.

    sheet.removeCustomFunction('FACTORIAL');
    sheet.clearCustomFunctions();
You can create your own function by inheriting the GC.Spread.CalcEngine.Functions.Function, as shown in the following code: The evaluate function can return a GC.Spread.CalcEngine.CalcArray object to represent the custom function returns an array as following code: After you have added your own function, if you want to remove it or clear all custom functions, use the removeCustomFunction or clearCustomFunctions method.
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 2 }); initSpread(spread); }; function initSpread(spread) { spread.options.allowDynamicArray = true; var sheet = spread.getSheet(0); sheet.setValue(1, 1, 'Press \'Add a Custom Function\' button'); sheet.setColumnWidth(1, 225); sheet.setColumnWidth(2, 100); function FactorialFunction() { this.name = "FACTORIAL"; this.maxArgs = 1; this.minArgs = 1; } FactorialFunction.prototype = new GC.Spread.CalcEngine.Functions.Function(); FactorialFunction.prototype.evaluate = function (arg) { var result = 1; if (arguments.length === 1 && !isNaN(parseInt(arg))) { for (var i = 1; i <= arg; i++) { result = i * result; } return result; } return "#VALUE!"; }; var factorial = new FactorialFunction(); function FactorialArrayFunction() { this.name = "FACTORIAL.ARRAY"; this.maxArgs = 1; this.minArgs = 1; } FactorialArrayFunction.prototype = new GC.Spread.CalcEngine.Functions.Function(); FactorialArrayFunction.prototype.evaluate = function (arg) { var t = 1; var result = [[]]; if (arguments.length === 1 && !isNaN(parseInt(arg))) { for (var i = 1; i <= arg; i++) { t = i * t; result[0].push(t); } return new GC.Spread.CalcEngine.CalcArray(result); } return "#VALUE!"; }; var factorialArray = new FactorialArrayFunction(); document.getElementById("addCustomFunction").addEventListener('click',function() { sheet.setValue(3, 1, 'Formula'); sheet.setValue(3, 2, '=FACTORIAL(5)'); sheet.setValue(4, 1, 'Result'); sheet.addCustomFunction(factorial); sheet.setFormula(4, 2, "=factorial(5)"); sheet.setValue(6, 1, 'Formula'); sheet.setValue(6, 2, '=FACTORIAL.ARRAY(5)'); sheet.setValue(7, 1, 'Result'); sheet.addCustomFunction(factorialArray); sheet.setFormula(7, 2, "=FACTORIAL.ARRAY(5)"); }); document.getElementById("removeCustomFunction").addEventListener('click',function() { sheet.removeCustomFunction("FACTORIAL"); sheet.removeCustomFunction("FACTORIAL.ARRAY"); sheet.recalcAll(true); }); };
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row"> <input type="button" value="Add a Custom Function(factorial)" id="addCustomFunction" /> <input type="button" value="Remove the Custom Function(factorial)" id="removeCustomFunction"/> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height:100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; overflow: auto; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; } .option-row { margin-bottom: 12px; } input[type=button] { padding: 4px 6px; margin-bottom: 6px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

You can create your own function by inheriting the GC.Spread.CalcEngine.Functions.Function, as shown in the following code:
The evaluate function can return a GC.Spread.CalcEngine.CalcArray object to represent the custom function returns an array as following code:
After you have added your own function, if you want to remove it or clear all custom functions, use the removeCustomFunction or clearCustomFunctions method.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
class FactorialFunction extends GC.Spread.CalcEngine.Functions.Function {
constructor() {
super("FACTORIAL", 1, 1);
}
evaluate (arg: number) {
let result = 1;
if (arguments.length === 1 && !isNaN(arg)) {
for (let i = 1; i <= arg; i++) {
result = i * result;
}
return result;
}
return "#VALUE!";
}
}
class FactorialArrayFunction extends GC.Spread.CalcEngine.Functions.Function {
constructor() {
super("FACTORIAL.ARRAY", 1, 1);
}
evaluate (arg: number) {
let t = 1;
let result: any[][] = [[]];
if (arguments.length === 1 && !isNaN(arg)) {
for (var i = 1; i <= arg; i++) {
t = i * t;
result[0].push(t);
}
return new GC.Spread.CalcEngine.CalcArray(result);
}
return "#VALUE!";
}
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
factorial: any;
factorialArray: any;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.options.allowDynamicArray = true;
let sheet = spread.getSheet(0);
sheet.setValue(1, 1, 'Press \'Add Custom Function\' button');
sheet.setColumnWidth(1, 225);
sheet.setColumnWidth(2, 100);
this.factorial = new FactorialFunction();
this.factorialArray = new FactorialArrayFunction();
}
addCustomFunction ($event: any) {
let sheet = this.spread.sheets[0];
sheet.addCustomFunction(this.factorial);
sheet.setValue(3, 1, 'Formula');
sheet.setValue(3, 2, '=FACTORIAL(5)');
sheet.setValue(4, 1, 'Result');
sheet.setFormula(4, 2, "=FACTORIAL(5)");
sheet.setValue(6, 1, 'Formula');
sheet.setValue(6, 2, '=FACTORIAL.ARRAY(5)');
sheet.setValue(7, 1, 'Result');
sheet.addCustomFunction(this.factorialArray);
sheet.setFormula(7, 2, "=FACTORIAL.ARRAY(5)");
}
removeCustomFunction ($event: any) {
let sheet = this.spread.sheets[0];
sheet.removeCustomFunction("FACTORIAL");
sheet.removeCustomFunction("FACTORIAL.ARRAY");
sheet.recalcAll(true);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<input type="button" value="Add a Custom Function(factorial)" id="addCustomFunction" (click)="addCustomFunction($event)" />
<input type="button" value="Remove the Custom Function(factorial)" id="removeCustomFunction" (click)="removeCustomFunction($event)" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
margin-bottom: 12px;
}
input[type=button] {
padding: 4px 6px;
margin-bottom: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

You can create your own function by inheriting the GC.Spread.CalcEngine.Functions.Function, as shown in the following code:
The evaluate function can return a GC.Spread.CalcEngine.CalcArray object to represent the custom function returns an array as following code:
After you have added your own function, if you want to remove it or clear all custom functions, use the removeCustomFunction or clearCustomFunctions method.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
class FactorialFunction extends GC.Spread.CalcEngine.Functions.Function {
constructor() {
super("FACTORIAL", 1, 1);
}
evaluate(arg) {
var result = 1;
if (arguments.length === 1 && !isNaN(arg)) {
for (var i = 1; i <= arg; i++) {
result = i * result;
}
return result;
}
return "#VALUE!";
}
}
class FactorialArrayFunction extends GC.Spread.CalcEngine.Functions.Function {
constructor() {
super("FACTORIAL.ARRAY", 1, 1);
}
evaluate(arg) {
let t = 1;
let result = [[]];
if (arguments.length === 1 && !isNaN(arg)) {
for (var i = 1; i <= arg; i++) {
t = i * t;
result[0].push(t);
}
return new GC.Spread.CalcEngine.CalcArray(result);
}
return "#VALUE!";
}
}
const useState = React.useState;
const factorial = new FactorialFunction();
const factorialArray = new FactorialArrayFunction();
export function AppFunc() {
const [spread, setSpread] = useState(null);
const initSpread = (spread) => {
setSpread(spread);
spread.options.allowDynamicArray = true;
var sheet = spread.getSheet(0);
sheet.setValue(1, 1, 'Press \'Add a Custom Function\' button');
sheet.setColumnWidth(1, 225);
sheet.setColumnWidth(2, 100);
}
const addCustomFunction = (e) => {
var sheet = spread.sheets[0];
sheet.addCustomFunction(factorial);
sheet.setValue(3, 1, 'Formula');
sheet.setValue(3, 2, '=FACTORIAL(5)');
sheet.setValue(4, 1, 'Result');
sheet.setFormula(4, 2, "=FACTORIAL(5)");
sheet.setValue(6, 1, 'Formula');
sheet.setValue(6, 2, '=FACTORIAL.ARRAY(5)');
sheet.setValue(7, 1, 'Result');
sheet.addCustomFunction(factorialArray);
sheet.setFormula(7, 2, "=FACTORIAL.ARRAY(5)");
}
const removeCustomFunction = (e) => {
var sheet = spread.sheets[0];
sheet.removeCustomFunction("FACTORIAL");
sheet.removeCustomFunction("FACTORIAL.ARRAY");
sheet.recalcAll(true);
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
addCustomFunction={(e) => addCustomFunction(e)}
removeCustomFunction={(e) => removeCustomFunction(e)}
/>
</div>;
}
function Panel(props) {
return (
<div class="options-container">
<div class="option-row">
<input type="button" value="Add a Custom Function(factorial)" onClick={(e) => { props.addCustomFunction(e) }} />
<input type="button" value="Remove the Custom Function(factorial)" onClick={(e) => { props.removeCustomFunction(e) }} />
</div>
</div>
)
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
class FactorialFunction extends GC.Spread.CalcEngine.Functions.Function {
constructor() {
super("FACTORIAL", 1, 1);
}
evaluate (arg) {
var result = 1;
if (arguments.length === 1 && !isNaN(arg)) {
for (var i = 1; i <= arg; i++) {
result = i * result;
}
return result;
}
return "#VALUE!";
}
}
class FactorialArrayFunction extends GC.Spread.CalcEngine.Functions.Function {
constructor() {
super("FACTORIAL.ARRAY", 1, 1);
}
evaluate (arg) {
let t = 1;
let result = [[]];
if (arguments.length === 1 && !isNaN(arg)) {
for (var i = 1; i <= arg; i++) {
t = i * t;
result[0].push(t);
}
return new GC.Spread.CalcEngine.CalcArray(result);
}
return "#VALUE!";
}
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
addCustomFunction={(e)=>{this.addCustomFunction(e)}}
removeCustomFunction={(e)=>{this.removeCustomFunction(e)}}
/>
</div>;
}
initSpread(spread) {
this.spread = spread;
spread.options.allowDynamicArray = true;
var sheet = spread.getSheet(0);
sheet.setValue(1, 1, 'Press \'Add a Custom Function\' button');
sheet.setColumnWidth(1, 225);
sheet.setColumnWidth(2, 100);
this.factorial = new FactorialFunction();
this.factorialArray = new FactorialArrayFunction();
}
addCustomFunction (e) {
var sheet = this.spread.sheets[0];
sheet.addCustomFunction(this.factorial);
sheet.setValue(3, 1, 'Formula');
sheet.setValue(3, 2, '=FACTORIAL(5)');
sheet.setValue(4, 1, 'Result');
sheet.setFormula(4, 2, "=FACTORIAL(5)");
sheet.setValue(6, 1, 'Formula');
sheet.setValue(6, 2, '=FACTORIAL.ARRAY(5)');
sheet.setValue(7, 1, 'Result');
sheet.addCustomFunction(this.factorialArray);
sheet.setFormula(7, 2, "=FACTORIAL.ARRAY(5)");
}
removeCustomFunction (e) {
var sheet = this.spread.sheets[0];
sheet.removeCustomFunction("FACTORIAL");
sheet.removeCustomFunction("FACTORIAL.ARRAY");
sheet.recalcAll(true);
}
}
class Panel extends Component{
constructor(props){
super(props);
}
render(){
return(
<div class="options-container">
<div class="option-row">
<input type="button" value="Add a Custom Function(factorial)" onClick={(e)=>{this.props.addCustomFunction(e)}} />
<input type="button" value="Remove the Custom Function(factorial)" onClick={(e)=>{this.props.removeCustomFunction(e)}} />
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
margin-bottom: 12px;
}
input[type=button] {
padding: 4px 6px;
margin-bottom: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.5-master-2026-07-21-2132/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can create your own function by inheriting the GC.Spread.CalcEngine.Functions.Function, as shown in the following code:
The evaluate function can return a GC.Spread.CalcEngine.CalcArray object to represent the custom function returns an array as following code:
After you have added your own function, if you want to remove it or clear all custom functions, use the removeCustomFunction or clearCustomFunctions method.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<input type="button" value="Add a Custom Function(factorial)" @click="addCustomFunction($event)" />
<input type="button" value="Remove the Custom Function(factorial)" @click="removeCustomFunction($event)" />
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import GC from "@mescius/spread-sheets";
let mySpread;
let factorial;
let factorialArray;
let initSpread = function (spread) {
mySpread = spread;
spread.options.allowDynamicArray = true;
let sheet = spread.getSheet(0);
sheet.setValue(1, 1, 'Press \'Add a Custom Function\' button');
sheet.setColumnWidth(1, 225);
sheet.setColumnWidth(2, 100);
function FactorialFunction() {
this.name = "FACTORIAL";
this.maxArgs = 1;
this.minArgs = 1;
}
FactorialFunction.prototype = new GC.Spread.CalcEngine.Functions.Function();
FactorialFunction.prototype.evaluate = function (arg) {
let result = 1;
if (arguments.length === 1 && !isNaN(parseInt(arg))) {
for (let i = 1; i <= arg; i++) {
result = i * result;
}
return result;
}
return "#VALUE!";
};
factorial = new FactorialFunction();
function FactorialArrayFunction() {
this.name = "FACTORIAL.ARRAY";
this.maxArgs = 1;
this.minArgs = 1;
}
FactorialArrayFunction.prototype = new GC.Spread.CalcEngine.Functions.Function();
FactorialArrayFunction.prototype.evaluate = function (arg) {
let t = 1;
let result = [[]];
if (arguments.length === 1 && !isNaN(parseInt(arg))) {
for (let i = 1; i <= arg; i++) {
t = i * t;
result[0].push(t);
}
return new GC.Spread.CalcEngine.CalcArray(result);
}
return "#VALUE!";
};
factorialArray = new FactorialArrayFunction();
}
let addCustomFunction = function(e) {
let sheet = mySpread.sheets[0];
sheet.addCustomFunction(factorial);
sheet.setValue(3, 1, 'Formula');
sheet.setValue(3, 2, '=FACTORIAL(5)');
sheet.setValue(4, 1, 'Result');
sheet.setFormula(4, 2, "=factorial(5)");
sheet.addCustomFunction(factorialArray);
sheet.setValue(6, 1, 'Formula');
sheet.setValue(6, 2, '=FACTORIAL.ARRAY(5)');
sheet.setValue(7, 1, 'Result');
sheet.setFormula(7, 2, "=FACTORIAL.ARRAY(5)");
}
let removeCustomFunction = function(e) {
let sheet = mySpread.sheets[0];
sheet.removeCustomFunction("FACTORIAL");
sheet.removeCustomFunction("FACTORIAL.ARRAY");
sheet.recalcAll(true);
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
margin-bottom: 12px;
}
input[type=button] {
padding: 4px 6px;
margin-bottom: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'cdn:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);